package com.ruoyi.oa.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.ruoyi.oa.domain.bo.OaInsuranceTemplateBo;
import com.ruoyi.oa.domain.vo.OaInsuranceTemplateVo;
import com.ruoyi.oa.domain.OaInsuranceTemplate;
import com.ruoyi.oa.mapper.OaInsuranceTemplateMapper;
import com.ruoyi.oa.service.IOaInsuranceTemplateService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 社保/公积金模板主Service业务层处理
 *
 * @author ruoyi
 * @date 2025-06-23
 */
@RequiredArgsConstructor
@Service
public class OaInsuranceTemplateServiceImpl implements IOaInsuranceTemplateService {

    private final OaInsuranceTemplateMapper baseMapper;

    /**
     * 查询社保/公积金模板主
     */
    @Override
    public OaInsuranceTemplateVo queryById(Long insuranceTemplateId){
        return baseMapper.selectVoById(insuranceTemplateId);
    }

    /**
     * 查询社保/公积金模板主列表
     */
    @Override
    public TableDataInfo<OaInsuranceTemplateVo> queryPageList(OaInsuranceTemplateBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<OaInsuranceTemplate> lqw = buildQueryWrapper(bo);
        Page<OaInsuranceTemplateVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询社保/公积金模板主列表
     */
    @Override
    public List<OaInsuranceTemplateVo> queryList(OaInsuranceTemplateBo bo) {
        LambdaQueryWrapper<OaInsuranceTemplate> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<OaInsuranceTemplate> buildQueryWrapper(OaInsuranceTemplateBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<OaInsuranceTemplate> lqw = Wrappers.lambdaQuery();
        lqw.like(StringUtils.isNotBlank(bo.getTemplateName()), OaInsuranceTemplate::getTemplateName, bo.getTemplateName());
        return lqw;
    }

    /**
     * 新增社保/公积金模板主
     */
    @Override
    public Boolean insertByBo(OaInsuranceTemplateBo bo) {
        OaInsuranceTemplate add = BeanUtil.toBean(bo, OaInsuranceTemplate.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setInsuranceTemplateId(add.getInsuranceTemplateId());
        }
        return flag;
    }

    /**
     * 修改社保/公积金模板主
     */
    @Override
    public Boolean updateByBo(OaInsuranceTemplateBo bo) {
        OaInsuranceTemplate update = BeanUtil.toBean(bo, OaInsuranceTemplate.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(OaInsuranceTemplate entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除社保/公积金模板主
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
